Package org.jboss.resteasy.plugins.providers

## Class FormUrlEncodedProvider

- java.lang.Object
- - org.jboss.resteasy.plugins.providers.FormUrlEncodedProvider

- All Implemented Interfaces:
    `javax.ws.rs.ext.MessageBodyReader<javax.ws.rs.core.MultivaluedMap>`, `javax.ws.rs.ext.MessageBodyWriter<javax.ws.rs.core.MultivaluedMap>`, `AsyncMessageBodyWriter<javax.ws.rs.core.MultivaluedMap>`
  Direct Known Subclasses:
    `ServerFormUrlEncodedProvider`

      @Provider
      @Produces("application/x-www-form-urlencoded")
      @Consumes("application/x-www-form-urlencoded")
      @ConstrainedTo(CLIENT)
      public class FormUrlEncodedProvider
      extends Object
      implements javax.ws.rs.ext.MessageBodyReader<javax.ws.rs.core.MultivaluedMap>, AsyncMessageBodyWriter<javax.ws.rs.core.MultivaluedMap>

  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FormUrlEncodedProvider()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `CompletionStage<Void>` | `asyncWriteTo​(javax.ws.rs.core.MultivaluedMap data, Class<?> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType, javax.ws.rs.core.MultivaluedMap<String,​Object> httpHeaders, AsyncOutputStream entityStream)` | Write a type to an HTTP message using async IO.
    `long` | `getSize​(javax.ws.rs.core.MultivaluedMap stringStringMultivaluedMap, Class<?> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType)` |
    `boolean` | `isReadable​(Class<?> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType)` |
    `boolean` | `isWriteable​(Class<?> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType)` |
    `static javax.ws.rs.core.MultivaluedMap<String,​String>` | `parseForm​(InputStream entityStream, String charset)` |
    `javax.ws.rs.core.MultivaluedMap` | `readFrom​(Class<javax.ws.rs.core.MultivaluedMap> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType, javax.ws.rs.core.MultivaluedMap<String,​String> httpHeaders, InputStream entityStream)` |
    `void` | `writeTo​(javax.ws.rs.core.MultivaluedMap data, Class<?> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType, javax.ws.rs.core.MultivaluedMap<String,​Object> httpHeaders, OutputStream entityStream)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FormUrlEncodedProvider

          public FormUrlEncodedProvider()

  - ### Method Detail

    - #### isReadable

          public boolean isReadable​(Class<?> type,
                                    Type genericType,
                                    Annotation[] annotations,
                                    javax.ws.rs.core.MediaType mediaType)

      Specified by:
        `isReadable` in interface `javax.ws.rs.ext.MessageBodyReader<javax.ws.rs.core.MultivaluedMap>`

    - #### readFrom

          public javax.ws.rs.core.MultivaluedMap readFrom​(Class<javax.ws.rs.core.MultivaluedMap> type,
                                                          Type genericType,
                                                          Annotation[] annotations,
                                                          javax.ws.rs.core.MediaType mediaType,
                                                          javax.ws.rs.core.MultivaluedMap<String,​String> httpHeaders,
                                                          InputStream entityStream)
                                                   throws IOException

      Specified by:
        `readFrom` in interface `javax.ws.rs.ext.MessageBodyReader<javax.ws.rs.core.MultivaluedMap>`
      Throws:
        `IOException`

    - #### parseForm

          public static javax.ws.rs.core.MultivaluedMap<String,​String> parseForm​(InputStream entityStream,
                                                                                       String charset)
                                                                                throws IOException

      Throws:
        `IOException`

    - #### isWriteable

          public boolean isWriteable​(Class<?> type,
                                     Type genericType,
                                     Annotation[] annotations,
                                     javax.ws.rs.core.MediaType mediaType)

      Specified by:
        `isWriteable` in interface `javax.ws.rs.ext.MessageBodyWriter<javax.ws.rs.core.MultivaluedMap>`

    - #### getSize

          public long getSize​(javax.ws.rs.core.MultivaluedMap stringStringMultivaluedMap,
                              Class<?> type,
                              Type genericType,
                              Annotation[] annotations,
                              javax.ws.rs.core.MediaType mediaType)

      Specified by:
        `getSize` in interface `javax.ws.rs.ext.MessageBodyWriter<javax.ws.rs.core.MultivaluedMap>`

    - #### writeTo

          public void writeTo​(javax.ws.rs.core.MultivaluedMap data,
                              Class<?> type,
                              Type genericType,
                              Annotation[] annotations,
                              javax.ws.rs.core.MediaType mediaType,
                              javax.ws.rs.core.MultivaluedMap<String,​Object> httpHeaders,
                              OutputStream entityStream)
                       throws IOException

      Specified by:
        `writeTo` in interface `javax.ws.rs.ext.MessageBodyWriter<javax.ws.rs.core.MultivaluedMap>`
      Throws:
        `IOException`

    - #### asyncWriteTo

          public CompletionStage<Void> asyncWriteTo​(javax.ws.rs.core.MultivaluedMap data,
                                                    Class<?> type,
                                                    Type genericType,
                                                    Annotation[] annotations,
                                                    javax.ws.rs.core.MediaType mediaType,
                                                    javax.ws.rs.core.MultivaluedMap<String,​Object> httpHeaders,
                                                    AsyncOutputStream entityStream)

      Description copied from interface: `AsyncMessageBodyWriter`
      Write a type to an HTTP message using async IO. The message header map is mutable but any changes must be made before writing to the async output stream since the headers will be flushed prior to writing the message body.
      Specified by:
        `asyncWriteTo` in interface `AsyncMessageBodyWriter<javax.ws.rs.core.MultivaluedMap>`
      Parameters:
        `data` - the instance to write.
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
        `httpHeaders` - a mutable map of the HTTP message headers.
        `entityStream` - the `AsyncOutputStream` for the HTTP entity. The implementation should not close the output stream.
      Returns:
        a `CompletionStage` indicating completion